#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <windows.h>

 // supporto per la converione delle strighe negli script di unsci.dll
 // le funzioni mid, instr, change, left, right
 // sono le stesse del basic.

char *mid(char *str,int pos,int nc);
int instr(char *st1,char *st2,int pos);
char *change(char *str, char *da, char *a);
char *left(char *str, int nc);
char *right(char *str, int nc);
char s[200],p1[200];

main()
{      // 0123456789012345678901234567890123456789012345678901234567890

 char *p="unafraseacaso -> <WINDOWS> <- unaltrafraseacaso";
 clrscr();
 printf("     01234567890123456789012345678901234567890123456\n");
 printf("P == %s\n\n",p);
 printf("3 caratteri a partire dalla locazione 5 == %s\n",mid(p,5,3));
 printf("posizone di partenza di \"unaltr\"        == %d\n\n",instr(p,"unaltr",1));
 printf("Cambio <WINDOWS> con \"pippo\"\n");
 printf("%s\n\n",change(p,"<WINDOWS>","pippo"));
 printf("i primi 10 caratteri a sinistra         == %s\n",left(p,10));
 printf("gli ultimi dieci caratteri a destra     == %s\n\n",right("taglia<WINDOWS>\\cuccurullo pp pippo",10));
 printf("Cambio <WINDOWS> con \"win9x\"\n");
 p=change(p,"<WINDOWS>","c:\\win9x\\");
 printf("%s\n",p);
 exit(0);
}



//------------------------------------------------------------------
// restituisce la substringa della stringa "str"
// "nc" caratteri dopo "pos" compreso
//------------------------------------------------------------------
char *mid(char *str,int pos,int nc)
{
 char s[0xff];
 int n,k=0;
 for(n=pos;n<=pos+nc-1;n++)
   s[k++]=str[n];
 s[k]=0;
 return(s);
}
//------------------------------------------------------------------




//------------------------------------------------------------------
// restituisce la stringa "str" sostituendo la substringa
// "da" con la substringa "a". Se "da" non viene trovata
// restituisce "str" senza modifiche.
//------------------------------------------------------------------
//------------------------------------------------------------------
char *change(char *str, char *da, char *a)
{
 char s[0xff];
 int pos=instr(str,da,0),k;
 if(pos<0)return(str);
 strcpy(s,mid(str,0,instr(str,da,0)));
 strcat(s,a);
 k=instr(str,da,0)+strlen(da);
 strcat(s,mid(str,k,strlen(str)-k));
 return(s);
}
//------------------------------------------------------------------



//------------------------------------------------------------------
// trova la posizione della substringa "st2" in "st1" a partire
// da "pos". Il primo carattere e' alla posizione 0.
//------------------------------------------------------------------
int instr(char *st1,char *st2,int pos)
{
 int tro,n,m;
 if(strlen(st1)<strlen(st2))return(-1);
 for(n=pos;n<=strlen(st1)-strlen(st2);n++){
  tro=1;
  for(m=n;m<=n+strlen(st2)-1;m++)
    if(st1[m]!=st2[m-n])tro=0;
    if(tro==1)return(n);}
 return(-1);
}
//------------------------------------------------------------------



//------------------------------------------------------------------
// restituisce gli ultimi "nc" caratteri di "str"
//------------------------------------------------------------------
char *left(char *str, int nc)
{
 return(mid(str,strlen(str)-nc,nc));
}
//------------------------------------------------------------------




//------------------------------------------------------------------
// restituisce i primi "nc" caratteri di "str"
//------------------------------------------------------------------
char *right(char *str, int nc)
{
 return(mid(str,0,nc));
}
//------------------------------------------------------------------

