Attribute VB_Name = "Module1"

'Dichiarazioni API
Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Public Sub SfumaForm(InputForm As Form, Optional ColoreIniziale As Variant, Optional PassoA As Variant, Optional PassoB As Variant)
   
   Dim PassoRiempimento As Single
   Dim c As Long
   Dim AreaDiRiempimento As RECT
   Dim i As Integer
   Dim oldm As Integer
   Dim hBrush As Long
   Dim c2(1 To 3) As Long
   Dim cs2(1 To 3) As Long
   Dim fs As Long
   Dim cs As Integer
      
   fs = IIf(IsMissing(PassoA), 64, CLng(PassoA))
   cs = IIf(IsMissing(PassoB), 4, CInt(PassoB))
   c = IIf(IsMissing(ColoreIniziale), vbBlue, CLng(ColoreIniziale))
   
   
   oldm = InputForm.ScaleMode
   InputForm.ScaleMode = vbPixels
   PassoRiempimento = InputForm.ScaleHeight / fs
   AreaDiRiempimento.Left = 0
   AreaDiRiempimento.Right = InputForm.ScaleWidth
   AreaDiRiempimento.Top = 0
   c2(1) = c And 255#
   cs2(1) = IIf(c2(1) > 0, cs, 0)
   c2(2) = (c \ 256#) And 255#
   cs2(2) = IIf(c2(2) > 0, cs, 0)
   c2(3) = (c \ 65536#) And 255#
   cs2(3) = IIf(c2(3) > 0, cs, 0)
   
   
   For i = 1 To fs
      AreaDiRiempimento.Bottom = PassoRiempimento * i
      hBrush = CreateSolidBrush(RGB(c2(1), c2(2), c2(3)))
      FillRect InputForm.hdc, AreaDiRiempimento, hBrush
      DeleteObject hBrush
      c2(1) = (c2(1) - cs2(1)) And 255#
      c2(2) = (c2(2) - cs2(2)) And 255#
      c2(3) = (c2(3) - cs2(3)) And 255#
      AreaDiRiempimento.Top = AreaDiRiempimento.Bottom
   Next i
   InputForm.ScaleMode = oldm
   
End Sub

